pflagchat/app/models.py
from app import db

class User(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(120), index=True, unique=False)
    email = db.Column(db.String(120), index=True, unique=True)
    blessed = db.Column(db.String(64), index=True, unique=False)
    admin = db.Column(db.String(64), index=True, unique=False)
    idtoken = db.Column(db.String(2000), index=True, unique=True)

    def __repr__(self):
        return '<User %r>' % (self.name)

pflagchat/app/__init__.py
from flask import Flask
from flask_socketio import SocketIO
from flask_sqlalchemy import SQLAlchemy

socketio = SocketIO()

app = Flask(__name__)
app.config.from_object('config')
db = SQLAlchemy(app)
from app import models

def create_app(debug=False):
    """Create an application."""
    app.debug = debug
    app.config['SECRET_KEY'] = 'gjr39dkjn344_!67#'

    from .main import main as main_blueprint
    app.register_blueprint(main_blueprint)

    socketio.init_app(app)
    return app

pflagchat/app/main/__init__.py
from flask import Blueprint

main = Blueprint('main', __name__)

from . import routes, events

pflagchat/app/main/routes.py
import json
import logging
from oauth2client import client, crypt
from sqlalchemy.orm.exc import NoResultFound

from flask import session, request, render_template, redirect, url_for

from . import main
from app import db, models


@main.route('/', methods=['GET', 'POST'])
def index():
    """"Visitors first page"""
    if request.method == 'GET':
        return render_template('caller-greet.html')
    if request.method == 'POST':
        return render_template('caller-chat.html')


@main.route('/volunteer', methods=['GET', 'POST'])
def volunteer_welcome():
    if request.method == 'GET':
        return render_template('volunteer-greet.html')
    if request.method == 'POST':
        return render_template('volunteer-chat.html')


@main.route('/login', methods=['GET', 'POST'])
def login_volunteer():
    if request.method == 'GET':
        return render_template('login.html')

    if request.method == 'POST':
        logging.warning(request.form.get('name'))
        email = request.form.get('email')
        u = models.User(name=request.form.get('name'),
                        email=email,
                        blessed='notyet',
                        admin='notyet',
                        idtoken=request.form.get('idtoken'))
        user_exists = db.session.query(models.User).filter_by(email=email).one_or_none()
        print 'user_exists: ', user_exists
        # TODO: Handle case where the following line fails. info here: https://developers.google.com/identity/sign-in/web/backend-auth
        # TODO: Also use the info sent back to server (name, email) from google,
        # instead of client's computer sending it back to us.
        idinfo = client.verify_id_token(request.form.get('idtoken'), None)
        if idinfo['iss'] not in ['accounts.google.com',
                                 'https://accounts.google.com']:
            raise crypt.AppIdentityError("Wrong issuer.")
        if user_exists:
        #this should really be checking the idtoken!
            logging.warning('user already in DB!')
            if (user_exists.blessed == 'notyet'):
                logging.warning('This initiate remains unblessed')
                return render_template('volunteer-awaitblessing.html')
            else:
                logging.warning('This blessed initiate is ready to serve the cause')
                session['name'] = 'Volunteer'
                return redirect(url_for('main.volunteer_welcome'))
        else:
            db.session.add(u)
            db.session.commit()
            logging.warning('This initiate awaits a blessing')
            return render_template('volunteer-awaitblessing.html')


@main.route('/admin', methods=['GET', 'POST'])
def login_admin():
    if request.method == 'GET':
        return render_template('admin-login.html')

    if request.method == 'POST':
    #    logging.warning('Login page debug is live')
        logging.warning(request.form.get('name'))
    #    logging.warning(request.form.get('email'))
    #    logging.warning(request.form.get('idtoken'))
        email = request.form.get('email')
        user_exists = db.session.query(models.User).filter_by(email=email, admin='fulladmin').one_or_none()
        if user_exists:

        #this should really be checking the idtoken!
            users_list = db.session.query(models.User).all()
            users_list_organized = [
                {
                    'name': user.name,
                    'email': user.email,
                    'blessed': user.blessed,
                    'admin': user.admin
                } for user in users_list]

            return render_template('admin-greet.html', users=users_list_organized)
        else:
            #log a warning that there was a login attempt
            return render_template('something-went-awry.html')


@main.route('/admin_action', methods=['POST'])
def admin_action():

    action_type = request.form.get('action_type')
    targetted_user = request.form.get('targetted_user')
    grant = json.loads(request.form.get('grant'))

    try:
        user = db.session.query(models.User).filter_by(email=targetted_user).one()
    except NoResultFound:
        logging.warning('no user found with email {0}!'.format(targetted_user))
        redirect(url_for('main.login_admin'))

    # Put all logging as warning because info doens't show up in console
    if action_type == 'blessing' and grant and user.blessed == 'notyet':
        user.blessed = 'blessed'
        logging.warning('blessed user {0}!'.format(targetted_user))
    elif action_type == 'blessing' and not grant and user.blessed == 'blessed':
        user.blessed = 'notyet'
        logging.warning('revoked access to user {0}!'.format(targetted_user))

    db.session.commit()

    # TODO: Separate login_admin from admin_greet
    return redirect(url_for('main.login_admin'))

pflagchat/app/templates/admin-greet.html
{% extends "base.html" %}

{% block easy_display %}
<div class="mdl-grid">
  <div class="mdl-cell mdl-cell--3-col">
  </div>
  <div class="mdl-cell mdl-cell--6-col">
    <div class="mdl-card mdl-shadow--8dp" style="width:100%">
      <div class="mdl-card__title">
        <h3>Admin Dashboard</h3>
      </div>
      <div class="mdl-card__supporting-text">
        <h6>
          <li>This would be the Admin Login page...</li>
          <li>The Admin Interface hasn't been integrated yet...</li>
          <li>Probably should do that!</li>
        </h6>

        <table style="width:100%">
          <tr>
            <th>Blessed</th>
            <th>Email</th>
            <th>Name</th>
            <th>Admin</th>
            <th>Delete</th>
          </tr>
        <script>
            function post(path, params, method) {
                console.log('DO WE GET INTO POST STUFF?');
              method = method || "post"; // Set method to post by default if not specified.

              // The rest of this code assumes you are not using a library.
              // It can be made less wordy if you use one.
              var form = document.createElement("form");
              form.setAttribute("method", method);
              form.setAttribute("action", path);
              for(var key in params) {
                  if(params.hasOwnProperty(key)) {
                      var hiddenField = document.createElement("input");
                      hiddenField.setAttribute("type", "hidden");
                      hiddenField.setAttribute("name", key);
                      hiddenField.setAttribute("value", params[key]);

                      form.appendChild(hiddenField);

                   }
              }

              document.body.appendChild(form);
              form.submit();
          };
        </script>


        {% for user in users %}
        <tr>
          <td>
              <label class="mdl-checkbox mdl-js-checkbox mdl-js-ripple-effect" id="show-dialog-{{ loop.index }}"
                     for="{{ user.name }}">
                <input type="checkbox" id="{{ user.name }}" {% if user.blessed == 'blessed' %} checked {% endif %} class="mdl-checkbox__input">
                <span class="mdl-checkbox__label"></span>
              </label>
          </td>
          <td>{{user.name}}</td>
          <td>{{user.email}}</td>
          <td>{{user.admin}}</td>
          <td>
              <i class="material-icons trash">delete_forever</i></td>
        </tr>

        <dialog class="mdl-dialog" id="dialog-{{ loop.index }}">
        <h4 class="mdl-dialog__title">Please Confirm</h4>
        <div class="mdl-dialog__content">
            You just
                {% if user.blessed == 'blessed' %}
                    unauthorized
                {% else %}
                    authorized
                {% endif %}
            user {{ user.name }} as a volunteer.  Did you mean to do this?
        </div>
        <div class="mdl-dialog__actions">
          <button type="button" class="mdl-button close-yes">Yes</button>
          <button type="button" class="mdl-button close-no">No</button>
        </div>
      </dialog>

      <script>
          ( function register_dialog_{{ loop.index }}() {
            var dialog = document.querySelector('#dialog-{{ loop.index }}');
            var showDialogButton = document.querySelector('#show-dialog-{{ loop.index }}');
            if (!dialog.showModal) {
                dialogPolyfill.registerDialog(dialog);
            }
            showDialogButton.addEventListener('click', function () {
                dialog.showModal();
            });
            dialog.querySelector('.close-yes').addEventListener('click', function () {
                dialog.close();
                post('/admin_action', {action_type: 'blessing', grant: {% if user.blessed == 'blessed' %} false {% elif user.blessed == 'notyet' %} true {% endif %}, targetted_user: '{{ user.email }}'});
                console.log('POSTed!');
            });
            dialog.querySelector('.close-no').addEventListener('click', function () {
                dialog.close();
                const checkbox = document.querySelector('#show-dialog-{{ loop.index }}').MaterialCheckbox;
                const is_checked = checkbox.inputElement_.checked;
                if (is_checked) {
                   checkbox.uncheck()
                } else {
                    checkbox.check()
                }
            });
        })()
      </script>
        {% endfor %}

        </table>


      </div>
    </div>
    <p></p>
  </div>
  <div class="mdl-cell mdl-cell--3-col">
  </div>
</div>

{% endblock %}

pflagchat/app/templates/admin-login.html
{% extends "base.html" %}

{% block rest_of_head %}
    <meta name="google-signin-scope" content="profile email">
    <meta name="google-signin-client_id" content="1001867967599-epp3u3t30nkap3a5h0dcs87hnnue6mff.apps.googleusercontent.com">
    <script src="https://apis.google.com/js/platform.js" async defer></script>
{% endblock %}

{% block easy_display %}
    <div class="g-signin2" data-onsuccess="onSignIn" data-theme="dark"></div>
    <script>
      function onSignIn(googleUser) {
        // Useful data for your client-side scripts:
        var profile = googleUser.getBasicProfile();
        console.log("ID: " + profile.getId()); // Don't send this directly to your server!
        console.log('Full Name: ' + profile.getName());
        console.log('Given Name: ' + profile.getGivenName());
        console.log('Family Name: ' + profile.getFamilyName());
        console.log("Image URL: " + profile.getImageUrl());
        console.log("Email: " + profile.getEmail());

        // The ID token you need to pass to your backend:
        var id_token = googleUser.getAuthResponse().id_token;
        console.log("ID Token: " + id_token);
        // Show the name for debugging
        document.getElementById("loggedinname").innerHTML = profile.getName();
        // SEND THE ID TOKEN TO THE SERVER
        function post(path, params, method) {
              method = method || "post"; // Set method to post by default if not specified.

              // The rest of this code assumes you are not using a library.
              // It can be made less wordy if you use one.
              var form = document.createElement("form");
              form.setAttribute("method", method);
              form.setAttribute("action", path);

              for(var key in params) {
                  if(params.hasOwnProperty(key)) {
                      var hiddenField = document.createElement("input");
                      hiddenField.setAttribute("type", "hidden");
                      hiddenField.setAttribute("name", key);
                      hiddenField.setAttribute("value", params[key]);

                      form.appendChild(hiddenField);
                   }
              }

              document.body.appendChild(form);
              form.submit();
          };
        post('/admin', {name: profile.getName(), email: profile.getEmail(), idtoken: googleUser.getAuthResponse().id_token});
        console.log('POSTed!');
      };
    </script>

    <h2>Logged in as <h2 id="loggedinname">nobody</h2></h2>

    <a href="#" onclick="signOut();">Sign out</a>
      <script>
        function signOut() {
          var auth2 = gapi.auth2.getAuthInstance();
          auth2.signOut().then(function () {
            console.log('User signed out.');
            // Show the name for debugging
            document.getElementById("loggedinname").innerHTML = "Nobody";
          });
        }
      </script>
{% endblock %}

pflagchat/app/templates/base.html
<!DOCTYPE html>
<html>
  <head>
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width, initial-scale=1.0">
      <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">
      <link rel="stylesheet" href="https://code.getmdl.io/1.2.1/material.amber-indigo.min.css" />
      <link rel="stylesheet" href="../static/style.css">
      <script defer src="https://code.getmdl.io/1.2.1/material.min.js"></script>
      <link rel="stylesheet" href="http://fonts.googleapis.com/css?family=Roboto:300,400,500,700" type="text/css">
      <title>Rainbow.Chat</title>
      <link rel="apple-touch-icon" sizes="57x57" href="../static/images/fav.ico/apple-icon-57x57.png">
      <link rel="apple-touch-icon" sizes="60x60" href="../static/images/fav.ico/apple-icon-60x60.png">
      <link rel="apple-touch-icon" sizes="72x72" href="../static/images/fav.ico/apple-icon-72x72.png">
      <link rel="apple-touch-icon" sizes="76x76" href="../static/images/fav.ico/apple-icon-76x76.png">
      <link rel="apple-touch-icon" sizes="114x114" href="../static/images/fav.ico/apple-icon-114x114.png">
      <link rel="apple-touch-icon" sizes="120x120" href="../static/images/fav.ico/apple-icon-120x120.png">
      <link rel="apple-touch-icon" sizes="144x144" href="../static/images/fav.ico/apple-icon-144x144.png">
      <link rel="apple-touch-icon" sizes="152x152" href="../static/images/fav.ico/apple-icon-152x152.png">
      <link rel="apple-touch-icon" sizes="180x180" href="../static/images/fav.ico/apple-icon-180x180.png">
      <link rel="icon" type="image/png" sizes="192x192"  href="../static/images/fav.ico/android-icon-192x192.png">
      <link rel="icon" type="image/png" sizes="32x32" href="../static/images/fav.ico/favicon-32x32.png">
      <link rel="icon" type="image/png" sizes="96x96" href="../static/images/fav.ico/favicon-96x96.png">
      <link rel="icon" type="image/png" sizes="16x16" href="../static/images/fav.ico/favicon-16x16.png">
      <link rel="manifest" href="manifest.json">
      <meta name="msapplication-TileColor" content="#ffffff">
      <meta name="msapplication-TileImage" content="ms-icon-144x144.png">
      <meta name="theme-color" content="#ffffff">
      <script type="text/javascript" src="//code.jquery.com/jquery-1.4.2.min.js"></script>
      <script type="text/javascript" src="//cdnjs.cloudflare.com/ajax/libs/socket.io/1.3.6/socket.io.min.js"></script>

        <link rel="stylesheet" type="text/css" href="../static/dialog-polyfill.css" />

        <script type="text/javascript" src="../static/dialog-polyfill.js"></script>

      <script type="text/javascript">
      function post(path, params, method) {
              method = method || "post"; // Set method to post by default if not specified.

              // The rest of this code assumes you are not using a library.
              // It can be made less wordy if you use one.
              var form = document.createElement("form");
              form.setAttribute("method", method);
              form.setAttribute("action", path);

              for(var key in params) {
                  if(params.hasOwnProperty(key)) {
                      var hiddenField = document.createElement("input");
                      hiddenField.setAttribute("type", "hidden");
                      hiddenField.setAttribute("name", key);
                      hiddenField.setAttribute("value", params[key]);

                      form.appendChild(hiddenField);
                   }
              }

              document.body.appendChild(form);
              form.submit();
          };
          </script>

{% block rest_of_head %}
{% endblock %}

    </head>

    <body>
        <div class="mdl-layout mdl-js-layout mdl-layout--fixed-header">
            <header class="mdl-layout__header">
                  <div class="mdl-layout__header-row">
                      <img class="logo-small grow" src="../static/images/rc-icon.png" alt="rainbow-chat-logo" id="logo">
                      <span class="mdl-layout-title">Welcome to Rainbow.Chat - Be kind</span>
                      <div class="mdl-layout-spacer"></div>

{% block escape_hatch %} {% endblock %}


                  </div>
                  <!-- Tabs Container -->
                  <div class="mdl-layout__tab-bar mdl-js-ripple-effect" id="tab_link_container"></div>
            </header>

            <main class="mdl-layout__content" id="tab_body_container">
{% block easy_display %} {% endblock %}
          </main>
      </div>
    </body>

</html>

pflagchat/app/templates/blessing-table.html
{# Table for users to include: Name, Email, Blessed?, Admin?, Delete? #}


<table style="width:100%">
  <tr>
    <th>Name</th>
    <th>Email</th>
    <th>Blessed</th>
    <th>Admin</th>
    <th>Delete</th>
  </tr>

{% for user in users %}
<tr>
  <td>{{user.name}}</td>
  <td>{{user.email}}</td>
  <td>{{user.blessed}}</td>
  <td>{{user.admin}}</td>
  <td>Delete {{user.name}}</td>
</tr>
{% endfor %}

</table>

pflagchat/app/templates/caller-chat.html
{% extends "chat-base.html" %}

{% block client_js %}
var role_for_client = 'caller'
{{ super() }}
{% endblock %}

{% block escape_hatch %}
    <a href="http://www.yahoo.com">
      <button class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect mdl-button--accent" id="panic">
          Leave Site Now!
      </button>
    </a>
    <span for="panic" class="mdl-tooltip">Panic Button Exits Chat Fast</span>
{% endblock %}

pflagchat/app/templates/caller-greet.html
{% extends "base.html" %}

{% block easy_display %}
     <main class="mdl-layout__content" style="width:100%;margin:auto;">
          <div class="mdl-card mdl-shadow--8dp" style="margin:auto;margin-top:100px">
            <div class="mdl-card__title">
		<img class="animated bounceIn" id="Logo-RC" src="../static/images/full-res-logo.png" alt="Logo-Rainbow-Chat">
	   <h3> Rainbow.Chat </h3>
            </div>
          <button class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect mdl-button--colored" type="submit" form="yo" style="width:100%"> Enter Chatroom  </button> </a>
<form method="POST" id="yo">

        </form>
          </div>

    </main>
{% endblock %}

pflagchat/app/templates/chat-base.html
{% extends "base.html" %}

{% block rest_of_head %}
      <script type="text/javascript" charset="utf-8">
{% block client_js %}
          var socket;
          $(document).ready(function() {
              socket = io.connect('http://' + document.domain + ':' + location.port);
              socket.on('connect', function() {
                  socket.emit(role_for_client + '_connects')
              });
              socket.on('enter_chat', function(data) {
                  var chat_room = data.room;

                  // create tab link
                  var tab_link_container = document.getElementById("tab_link_container");
                  var tab_link = document.createElement("a");
                  var tab_href = "scroll-tab-" + chat_room;
                  tab_link.setAttribute('href', '#' + tab_href);
                  tab_link.setAttribute('class', 'mdl-layout__tab is-active');
                  tab_link.innerHTML = "Room";
                  tab_link_container.appendChild(tab_link);

                  // create tab body
                  var tab_body_container = document.getElementById("tab_body_container");
                  var tab_body = document.createElement("section");
                  tab_body.setAttribute('class', "mdl-layout__tab-panel is-active");
                  tab_body.setAttribute('id', tab_href);
                  tab_body_container.appendChild(tab_body);

                  //create input element
                  var input_field = document.createElement('input');
                  input_field.setAttribute('class', 'text mdl-textfield__input');
                  input_field.setAttribute('type', 'text');
                  input_field.setAttribute('id', chat_room);

                  // fill body with tasty divs
                  var form_grid = document.createElement('div');
                  form_grid.setAttribute('class', 'mdl-grid text-grid');

                  var text_holder = document.createElement('div');
                  text_holder.setAttribute('class', "mdl-cell mdl-cell--11-col mdl-textfield mdl-js-textfield mdl-textfield--floating-label");

                  var input_label = document.createElement('label');
                  input_label.setAttribute('for', chat_room);
                  input_label.setAttribute('class', "mdl-textfield__label");
                  input_label.innerHTML = "Enter a message...";

                  tab_body.appendChild(form_grid);
                  form_grid.appendChild(text_holder);
                  text_holder.appendChild(input_field);
                  text_holder.appendChild(input_label);

                  var icon = document.createElement('i');
                  icon.setAttribute('class', "material-icons");
                  icon.innerHTML = 'send';

                  var send_button = document.createElement('button');
                  send_button.setAttribute('class', "mdl-button mdl-button--fab mdl-button--accent mdl-js-button mdl-js-ripple-effect");

                  var button_div = document.createElement('div');
                  button_div.setAttribute('class', "mdl-cell mdl-cell--middle mdl-cell--stretch mdl-cell--1-col");

                  send_button.appendChild(icon);
                  button_div.appendChild(send_button);
                  form_grid.appendChild(button_div);

                  $('.text').keypress(function(e) {
                      var code = e.keyCode || e.which;
                      if (code == 13) {
                          text = $(e.target).val();
                          $(e.target).val('');
                          socket.emit(role_for_client + '_speaks', {msg: text}, {room: chat_room});
                      }
                  });

                  componentHandler.upgradeElement(text_holder);

              });

              socket.on('message', function(data) {
                  var msg = data.msg;
                  if (data.role != role_for_client) {
                  var name = data.role
                } else { var name = role_for_client}
                  var room = data.room;
                  var role = data.role;
                  var bigPapa = document.createElement("div");

                  bigPapa.className = "mdl-list__item";

                  var iconElContainer = document.createElement("span");
                  iconElContainer.className = "mdl-list__item-primary-content";
                  var iconEl = document.createElement("i");
                  iconEl.className = "material-icons mdl-list__item-avatar";
                  iconEl.innerHTML = "person";
                  var nameContainer = document.createElement("span");
                  nameContainer.innerHTML = name ? name: 'Volunteer';
                  var messageContainer = document.createElement("div");
                  messageContainer.className = "bubble";
                  var message = document.createElement("p");
                  message.innerHTML = msg;
                  messageContainer.appendChild(message);
                  var itgoeshere = document.getElementById("scroll-tab-" + room);
                  itgoeshere.appendChild(bigPapa);

  if (data.role != role_for_client) {
                      iconElContainer.appendChild(iconEl);
                      iconElContainer.appendChild(nameContainer);
                      bigPapa.appendChild(iconElContainer);
                      bigPapa.appendChild(messageContainer);
   } else {
                      var spacer = document.createElement("div");
                      spacer.className = "mdl-layout-spacer";

                      iconElContainer.appendChild(spacer);
                      iconElContainer.appendChild(nameContainer);
                      iconElContainer.appendChild(iconEl);
                      messageContainer.classList.add("bubble-alt");
                      bigPapa.appendChild(messageContainer);
                      bigPapa.appendChild(iconElContainer);
    };

              });

          });

          window.onbeforeunload = leave_room;

          function leave_room() {
              socket.emit(role_for_client + '_disconnects', {room: room}, function() {
                  socket.disconnect();
                  // go back to the login page
                  window.location.href = "{{ url_for('main.index') }}";
              });
          }

{% endblock client_js %}
      </script>
{% endblock rest_of_head %}

    </head>

    <body>
        <div class="mdl-layout mdl-js-layout mdl-layout--fixed-header">
            <header class="mdl-layout__header">
                  <div class="mdl-layout__header-row">
                      <img class="logo-small grow" src="../static/images/rc-icon.png" alt="rainbow-chat-logo" id="logo">
                      <span class="mdl-layout-title">Welcome to Rainbow.Chat - Be kind</span>
                      <div class="mdl-layout-spacer"></div>

{% block escape_hatch %} {% endblock %}


                  </div>
                  <!-- Tabs Container -->
                  <div class="mdl-layout__tab-bar mdl-js-ripple-effect" id="tab_link_container"></div>
            </header>

            <main class="mdl-layout__content" id="tab_body_container"></main>
      </div>
    </body>

</html>

pflagchat/app/templates/login.html
{% extends "base.html" %}

{% block rest_of_head %}
    <meta name="google-signin-scope" content="profile email">
    <meta name="google-signin-client_id" content="1001867967599-epp3u3t30nkap3a5h0dcs87hnnue6mff.apps.googleusercontent.com">
    <script src="https://apis.google.com/js/platform.js" async defer></script>
{% endblock %}

{% block easy_display %}
    <div class="g-signin2" data-onsuccess="onSignIn" data-theme="dark"></div>
    <script>
      function onSignIn(googleUser) {
        // Useful data for your client-side scripts:
        var profile = googleUser.getBasicProfile();
        console.log("ID: " + profile.getId()); // Don't send this directly to your server!
        console.log('Full Name: ' + profile.getName());
        console.log('Given Name: ' + profile.getGivenName());
        console.log('Family Name: ' + profile.getFamilyName());
        console.log("Image URL: " + profile.getImageUrl());
        console.log("Email: " + profile.getEmail());

        // The ID token you need to pass to your backend:
        var id_token = googleUser.getAuthResponse().id_token;
        console.log("ID Token: " + id_token);
        // Show the name for debugging
        document.getElementById("loggedinname").innerHTML = profile.getName();
        // SEND THE ID TOKEN TO THE SERVER
        function post(path, params, method) {
              method = method || "post"; // Set method to post by default if not specified.

              // The rest of this code assumes you are not using a library.
              // It can be made less wordy if you use one.
              var form = document.createElement("form");
              form.setAttribute("method", method);
              form.setAttribute("action", path);

              for(var key in params) {
                  if(params.hasOwnProperty(key)) {
                      var hiddenField = document.createElement("input");
                      hiddenField.setAttribute("type", "hidden");
                      hiddenField.setAttribute("name", key);
                      hiddenField.setAttribute("value", params[key]);

                      form.appendChild(hiddenField);
                   }
              }

              document.body.appendChild(form);
              form.submit();
          };
        post('/login', {name: profile.getName(), email: profile.getEmail(), idtoken: googleUser.getAuthResponse().id_token});
        console.log('POSTed!');
      };
    </script>

    <h2>Logged in as <h2 id="loggedinname">nobody</h2></h2>

    <a href="#" onclick="signOut();">Sign out</a>
      <script>
        function signOut() {
          var auth2 = gapi.auth2.getAuthInstance();
          auth2.signOut().then(function () {
            console.log('User signed out.');
            // Show the name for debugging
            document.getElementById("loggedinname").innerHTML = "Nobody";
          });
        }
      </script>
{% endblock %}

pflagchat/app/templates/something-went-awry.html
{% extends "base.html" %}

{% block easy_display %}
<div class="mdl-grid">
  <div class="mdl-cell mdl-cell--3-col">
  </div>
  <div class="mdl-cell mdl-cell--6-col">
    <div class="mdl-card mdl-shadow--8dp" style="width:100%">
      <div class="mdl-card__title">
        <h3>You're not Admin!</h3>
      </div>
      <div class="mdl-card__supporting-text">
        <h6>
          <li>Something went awry!!!!!!!!!</li>
        </h6>
      </div>
    </div>
    <p></p>
  </div>
  <div class="mdl-cell mdl-cell--3-col">
  </div>
</div>

{% endblock %}

pflagchat/app/templates/volunteer-awaitblessing.html
{% extends "base.html" %}
{% block easy_display %}
<main class="mdl-layout__content" style="width:100%;margin:auto;">
    <div class="mdl-card mdl-shadow--2dp" style="margin:auto;margin-top:100px">
        <div class="mdl-card__title"> <img class="animated bounceIn" id="Logo-RC" src="../static/images/full-res-logo.png" alt="Logo-Rainbow-Chat">
            <h3> Rainbow.Chat </h3>
        </div>
            <p> Thank you for registering!
              <br>
             The Admins will bless you soon! And style this page!
           </p>
    </div>
</main>
{% endblock %}

pflagchat/app/templates/volunteer-chat.html
{% extends "chat-base.html" %}

{% block client_js %}
var role_for_client = 'volunteer'
{{ super() }}
{% endblock %}